package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLSetList_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLSetList extends JNIObject  {
	
	/* @generated */
	protected ISLSetList(long ptr) {
		/*** PROTECTED REGION ID(ISLSetList_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLSetList build(long ptr) {
		return new ISLSetList(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLSetList_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_set_list_alloc 
	 * 
	 * @generated
	**/
	 public static ISLSetList build(ISLContext ctx, int n) { 
		/*** PROTECTED REGION ID(static_isl_set_list_alloc) DISABLED START ***/
		ISLSetList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSetList.build(ISLNative.isl_set_list_alloc(getNativePtr(ctx), n));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_list_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLSetList setlist, int format) { 
		/*** PROTECTED REGION ID(static_isl_set_list_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_list_to_string(getNativePtr(setlist), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_set_list_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_set_list_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_set_list_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_list_copy 
	 * 
	 * @generated
	**/
	public ISLSetList copy() {
		/*** PROTECTED REGION ID(isl_set_list_copy) DISABLED START ***/
		ISLSetList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSetList.build(ISLNative.isl_set_list_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_list_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_set_list_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_set_list_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_list_n_set 
	 * 
	 * @generated
	**/
	public int getNbSets() {
		/*** PROTECTED REGION ID(isl_set_list_n_set) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_list_n_set(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_list_get_set 
	 * 
	 * @generated
	**/
	public ISLSet get(int index) {
		/*** PROTECTED REGION ID(isl_set_list_get_set) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSet.build(ISLNative.isl_set_list_get_set(getNativePtr(this), index));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_list_set_set 
	 * 
	 * @take this set
	 * @generated
	**/
	public ISLSetList set(int index, ISLSet set) {
		/*** PROTECTED REGION ID(isl_set_list_set_set) DISABLED START ***/
		ISLSetList res;
		
		synchronized(LOCK) {
			checkParameters(this, set);
			try {
				res = ISLSetList.build(ISLNative.isl_set_list_set_set(getNativePtr(this), index, getNativePtr(set)));
			} finally {
				taken(this);
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_list_insert 
	 * 
	 * @take this el
	 * @generated
	**/
	public ISLSetList insert(int pos, ISLSet el) {
		/*** PROTECTED REGION ID(isl_set_list_insert) DISABLED START ***/
		ISLSetList res;
		
		synchronized(LOCK) {
			checkParameters(this, el);
			try {
				res = ISLSetList.build(ISLNative.isl_set_list_insert(getNativePtr(this), pos, getNativePtr(el)));
			} finally {
				taken(this);
				taken(el);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_list_add 
	 * 
	 * @take this el
	 * @generated
	**/
	public ISLSetList add(ISLSet el) {
		/*** PROTECTED REGION ID(isl_set_list_add) DISABLED START ***/
		ISLSetList res;
		
		synchronized(LOCK) {
			checkParameters(this, el);
			try {
				res = ISLSetList.build(ISLNative.isl_set_list_add(getNativePtr(this), getNativePtr(el)));
			} finally {
				taken(this);
				taken(el);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_list_drop 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSetList drop(int first, int n) {
		/*** PROTECTED REGION ID(isl_set_list_drop) DISABLED START ***/
		ISLSetList res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSetList.build(ISLNative.isl_set_list_drop(getNativePtr(this), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_list_concat 
	 * 
	 * @take this list2
	 * @generated
	**/
	public ISLSetList concat(ISLSetList list2) {
		/*** PROTECTED REGION ID(isl_set_list_concat) DISABLED START ***/
		ISLSetList res;
		
		synchronized(LOCK) {
			checkParameters(this, list2);
			try {
				res = ISLSetList.build(ISLNative.isl_set_list_concat(getNativePtr(this), getNativePtr(list2)));
			} finally {
				taken(this);
				taken(list2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLSetList_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
